#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct stack_node {
    double number;
    struct stack_node *next;
};

struct stack_node *push(struct stack_node *top, double number)
{
    struct stack_node *new_node = (struct stack_node *) malloc(sizeof(struct stack_node));
    if (new_node) {
        new_node->number = number;
        new_node->next = top;
        top = new_node;
    }
    return top;
}

double pop(struct stack_node **top)
{
    double result = 0.0;
    if (*top) {
        result = (*top)->number;
        struct stack_node *temporary = (*top)->next;
        free(*top);
        *top = temporary;
    }
    return result;
}

double evaluate(char *token)
{
    static struct stack_node *top = 0;
    double first_argument, second_argument;
    switch (token[0]) {
    case '+':
        top = push(top, pop(&top) + pop(&top));
        break;
    case '*':
        top = push(top, pop(&top) * pop(&top));
        break;
    case '-':
        second_argument = pop(&top);
        first_argument = pop(&top);
        top = push(top, first_argument - second_argument);
        break;
    case '/':
        second_argument = pop(&top);
        first_argument = pop(&top);
        top = push(top, first_argument/second_argument);
        break;
    case '=':
        return pop(&top);
    default:
        top = push(top, atof(token));
    }
    return 0.0;
}

double parse(char expression[])
{
    double result = 0.0;
    char *token = strtok(expression, " ");
    while (token) {
        result = evaluate(token);
        token = strtok(0, " ");
    }
    return result;
}

int main(void)
{
    char rpn_expression[201];

    puts("Proszę wprowadzić wyrażenie w ONP:");
    scanf("%200[^\n]s", rpn_expression);
    double result = parse(rpn_expression);
    printf("Wynik: %.3lf\n", result);
    return 0;
}
